#include "stdafx.h"
#include "Disciplina.h"

Disciplina::Disciplina(int i, int na, char* ac)
{
	id = i;
	DeptoAssociado = NULL;
	strcpy (area_conhecimento, ac );
}

Disciplina::~Disciplina()
{
	DeptoAssociado  = NULL;
	Elemento<Matricula*> *aux1, *aux2 = ObjLMatriculas.getPrimeiro();
	while (NULL != aux2)
	{
		aux1 = aux2->getProximo();
		delete aux2->getInfo();
		aux2 = aux1;
	}
}

void  Disciplina::setId ( int i ) 		
{ 
	id = i;
}

int Disciplina::getId()
{
	return id;
}

void  Disciplina::setNome(char* n)  	
{  
	strcpy(nome, n);  
}

char* Disciplina::getNome()
{  
	return nome;  
}

void Disciplina::setDepartamento(Departamento* d)
{
	// Cada vez que um Departamento  associado a uma Disciplina,
	// esta Disciplina passa a fazer parte da lista de disciplina 
	// do Departamento, por meio do comando abaixo.
	DeptoAssociado = d;
	DeptoAssociado->setDisciplina ( this );
}

Departamento* Disciplina::getDepartamento ( )
{
	return  DeptoAssociado;
}

void Disciplina::incluaAluno( Aluno* pa )
{
	Matricula* nova = new Matricula;
	nova->setAluno( pa );
	ObjLMatriculas.incluir( nova );
}

bool Disciplina::incluirPriParcial(int RA, float nota)
{
	Elemento<Matricula*>* elem = ObjLMatriculas.getPrimeiro();
	while (NULL != elem)
	{
		if (elem->getInfo()->getAluno()->getRA() == RA)
		{
			Matricula* mat = elem->getInfo();
			mat->setPriParcial( nota );
			return true;
		}
		elem = elem->getProximo();
	}
	return false;
}

bool Disciplina::incluirSegParcial(int RA, float nota)
{
	Elemento<Matricula*>* elem = ObjLMatriculas.getPrimeiro();
	while (NULL != elem)
	{
		if (elem->getInfo()->getAluno()->getRA() == RA)
		{
			Matricula* mat = elem->getInfo();
			mat->setSegParcial( nota );
			return true;
		}
		elem = elem->getProximo();
	}
	return false;
}

bool Disciplina::incluirFinal(int RA, float nota)
{
	Elemento<Matricula*>* elem = ObjLMatriculas.getPrimeiro();
	while (NULL != elem)
	{
		if (elem->getInfo()->getAluno()->getRA() == RA)
		{
			Matricula* mat = elem->getInfo();
			float media = (mat->getPriParcial() + mat->getSegParcial())/2.0f;
			if ( media < 7.0f && media >= 4.0f )
			{
				mat->setFinal( nota );
				return true;
			}
			break;
		}
		elem = elem->getProximo();
	}
	return false;
}

bool Disciplina::incluirFaltas(int RA, int faltas)
{
	Elemento<Matricula*>* elem = ObjLMatriculas.getPrimeiro();
	while (NULL != elem)
	{
		if (elem->getInfo()->getAluno()->getRA() == RA)
		{
			Matricula* mat = elem->getInfo();
			mat->addFaltas( faltas );
			return true;
		}
		elem = elem->getProximo();
	}
	return false;
}

void Disciplina::listeAlunos()
{
	Elemento<Matricula*>* elem = ObjLMatriculas.getPrimeiro();
	while (NULL != elem)
	{
		Aluno* obj = elem->getInfo()->getAluno();
		printf("%s\n", obj->getNome());
		elem = elem->getProximo();
	}
}

void Disciplina::listeAlunos2()
{
    Elemento<Matricula*>* elem = ObjLMatriculas.getUltimo();
	while (NULL != elem)
	{
		Aluno* obj = elem->getInfo()->getAluno();
		printf("%s\n", obj->getNome());
		elem = elem->getAnterior();
	}
}

void Disciplina::listeAlunos3()
{
	Elemento<Matricula*>* elem = ObjLMatriculas.getPrimeiro();
	printf("\nRA\t1Parcial\t2Parcial\tFaltas\t\tFinal\n\n");
	while (NULL != elem)
	{
		Matricula* mat = elem->getInfo();

		printf("%d\t", mat->getAluno()->getId());
		printf("%.2f\t\t", mat->getPriParcial());
		printf("%.2f\t\t", mat->getSegParcial());
		printf("%d\t\t", mat->getFaltas());
		if (mat->getFinal() != -1.0f)
			printf("%.2f", mat->getFinal());
		printf("\n");

		elem = elem->getProximo();
	}	
}
